#include "intro.h"
#include "lzr.h"
#include "cfg.h"
#include <math.h>
#include <stdlib.h>

double hand_x, hand_y;
static double stamp_x, stamp_y;
static int delay;
static int hold;

void intro_init(void)
{
	hand_x = (double)CFG_DWIDTH - (double)CFG_DWIDTH / 5;
	hand_y = (double)CFG_DHEIGHT / 2;
	stamp_x = (double)CFG_DWIDTH / 5;
	stamp_y = (double)CFG_DHEIGHT / 2;
	delay = 90;
	hold = 0;
}

int intro_update(void)
{
	if (delay <= 0) {
		hand_x += LZR_BUTTON(RIGHT) - LZR_BUTTON(LEFT);
		hand_y += LZR_BUTTON(DOWN) - LZR_BUTTON(UP);
		hand_x += (CFG_DWIDTH / 2.0 - hand_x) * 0.2;
		hand_y += (CFG_DWIDTH / 2.0 - hand_y) * 0.2;
	} else {
		hand_x += (stamp_x - hand_x) * 0.02;
		stamp_x += ((double)CFG_DWIDTH / 2 - stamp_x) * 0.04;
	}
	delay -= (delay > 0);
	const int prev_hold = hold;
	hold = (delay <= 0) && LZR_BUTTON(O);
	return (prev_hold && !hold);
}

void intro_draw(void)
{
	const int shake = hold;
	LZR_DrawSetColor(shake ? shake : (double)(rand() & 1) / 40,
	                 (double)(rand() & 1) / 40,
	                 (double)(rand() & 1) / 40,
	                 1);
	LZR_DrawClear();
	LZR_ImageDrawSettings stg = {
		0, 0, -1, -1, 1.0, 1.0,
		sin((double)(LZR_GetTick() % 32)) * (1.0 + 3.0 * shake),
		true, false, false
	};
	LZR_DrawSetColor(1, 1, 1, 1);
	LZR_DrawImageEx(2, stamp_x + 10, stamp_y, stg);
	LZR_DrawSetColor(1, 1, 1, 0.9 + 0.1 * shake);
	LZR_DrawImageEx(shake,
					hand_x + shake * (rand() % 8),
					hand_y + shake * (rand() % 8),
					stg);
	LZR_DrawSetColor(1, 1, 1, 1);
	if (shake) {
		LZR_DrawImageEx(3, stamp_x + 10, stamp_y, stg);
		LZR_DrawSetColor(rand() & 1, 0, 0, 1);
		LZR_DrawImageEx(5, CFG_DWIDTH / 2, 20, stg);
		LZR_DrawImageEx(4, CFG_DWIDTH / 2, CFG_DHEIGHT - 18, stg);
	}
}
