#include "musi.h"
#include "lzr.h"
#include "cfg.h"
#include <math.h>
#include <stdlib.h>

extern double hand_x, hand_y;
static int delay;
static int wildass_x, wildass_y;
static int hold;
static int inspi;

void musi_init(void)
{
	delay = 12;
	wildass_x = CFG_DWIDTH / 2 - CFG_DWIDTH;
	wildass_y = CFG_DHEIGHT / 2 - CFG_DHEIGHT;
	hold = 0;
	inspi = 0;
}

int musi_update(void)
{
	hand_x += LZR_BUTTON(RIGHT) - LZR_BUTTON(LEFT);
	hand_y += LZR_BUTTON(DOWN) - LZR_BUTTON(UP);
	hand_x += (CFG_DWIDTH / 2.0 - hand_x) * 0.1;
	hand_y += (CFG_DWIDTH / 2.0 - hand_y) * 0.1;
	delay -= (delay > 0);
	if (delay <= 0) {
		wildass_x = CFG_DWIDTH / 2;
		wildass_y = CFG_DHEIGHT / 2;
		wildass_x += CFG_DWIDTH * ((rand() & 1) ? -1 : 1);
		wildass_y += CFG_DHEIGHT * ((rand() & 1) ? -1 : 1);
		delay = 12;
	}
	const int prev_hold = hold;
	hold = LZR_BUTTON(O);
	if (!prev_hold && hold)
		inspi += 1;
	return (inspi > 4);
}

void musi_draw(void)
{
	LZR_DrawSetColor((double)(rand() & 1) / 40,
	                 (double)(rand() & 1) / 40,
	                 (double)(rand() & 1) / 40,
	                 1);
	LZR_DrawClear();
	LZR_ImageDrawSettings stg = {
		0, 0, -1, -1, 1.0, 1.0,
		sin((double)(LZR_GetTick() % 32)) * 1.0,
		true, false, false
	};
	LZR_DrawSetColor(1, 1, 1, 0.2);
	LZR_DrawImageEx(0,
					hand_x,
					hand_y,
					stg);
	LZR_DrawSetColor(rand() & 1, rand() & 1, rand() & 1, 1);
	LZR_DrawImageEx(6,
					wildass_x,
					wildass_y,
					stg);
	if (inspi) {
		stg.angle = rand();
		LZR_DrawImageEx(6 + inspi, hand_x, hand_y, stg);
	}
}
